/* 
 * File:   NFTDialog.h
 * Author: binnette
 *
 * Created on 5 juin 2010, 16:10
 */

#ifndef _NFTDIALOG_H
#define	_NFTDIALOG_H

#include <gtkmm-2.4/gtkmm.h>
#include "Category.h"

class NFTDialog : public Gtk::Window {
public:
    NFTDialog();
    virtual ~NFTDialog();
private:
    //functions
    void create_categories();
    void show_template_from_categorie_index(int index);
    void show_info_from_template_index(int index);
    //Signal handlers:
    void on_button_ok_clicked();
    void on_button_cancel_clicked();
    void on_treeview_categories_selection_changed();
    void on_treeview_templates_selection_changed();

    //Template selected
    Template *m_template_selected;
    
    //Member widgets:

    //Button
    Gtk::Button m_button_ok;
    Gtk::Button m_button_cancel;
    //Frame
    Gtk::Frame m_frame_categories;
    Gtk::Frame m_frame_templates;
    Gtk::Frame m_frame_preview_info;
    //HBox
    Gtk::HBox m_hbox_frame;
    Gtk::HBox m_hbox_action;
    //Image
    Gtk::Image m_image_preview;
    //TreeView
    Gtk::TreeView m_treeview_categories;
    Gtk::TreeView m_treeview_templates;
    Gtk::TreeView m_treeview_info;
    //VBox
    Gtk::VBox m_vbox_global;
    Gtk::VBox m_vbox_preview_info;

    //Categories storage
    std::vector<Category> m_categories;
    std::vector<Template> m_templates_currents;

    class ModelColumnsCategories : public Gtk::TreeModelColumnRecord {
    public:

        ModelColumnsCategories() {
            add(m_col_categorie_name);
            add(m_col_categorie_index);
        }

        Gtk::TreeModelColumn<Glib::ustring> m_col_categorie_name;
        Gtk::TreeModelColumn<int> m_col_categorie_index;

    };

    ModelColumnsCategories m_columns_categories;

    Glib::RefPtr<Gtk::ListStore> m_refListStore_categories;
    Glib::RefPtr<Gtk::TreeSelection> refTreeSelection_categories;

    //Templates storage

    class ModelColumnsTemplates : public Gtk::TreeModelColumnRecord {
    public:

        ModelColumnsTemplates() {
            add(m_col_template_name);
            add(m_col_template_index);
        }

        Gtk::TreeModelColumn<Glib::ustring> m_col_template_name;
        Gtk::TreeModelColumn<int> m_col_template_index;

    };

    ModelColumnsTemplates m_columns_templates;

    Glib::RefPtr<Gtk::ListStore> m_refListStore_templates;
    Glib::RefPtr<Gtk::TreeSelection> refTreeSelection_templates;

    //Info storage

    class ModelColumnsInfo : public Gtk::TreeModelColumnRecord {
    public:

        ModelColumnsInfo() {
            add(m_col_template_tag);
            add(m_col_template_value);
        }

        Gtk::TreeModelColumn<Glib::ustring> m_col_template_tag;
        Gtk::TreeModelColumn<Glib::ustring> m_col_template_value;

    };

    ModelColumnsInfo m_columns_info;

    Glib::RefPtr<Gtk::ListStore> m_refListStore_info;
    Glib::RefPtr<Gtk::TreeSelection> refTreeSelection_info;
};

#endif	/* _NFTDIALOG_H */

